
#include <QQmlContext>
#include <QApplication>

#include <QQmlApplicationEngine>

#include <customobject.h>
#include <objectcaller.h>


int main(int argc, char *argv[])
{
    qputenv("QT_IM_MODULE", QByteArray("qtvirtualkeyboard"));

    if (qEnvironmentVariableIsEmpty("QTGLESSTREAM_DISPLAY")) {
        qputenv("QT_QPA_EGLFS_PHYSICAL_WIDTH", QByteArray("213"));
        qputenv("QT_QPA_EGLFS_PHYSICAL_HEIGHT", QByteArray("120"));

        QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    }
    CustomObject object;
    ObjectCaller objectCaller;
    qmlRegisterUncreatableType<CustomObject>      ("CustomObject"    ,1,0,"CustomObject"    , "");

    QObject::connect(&objectCaller, &ObjectCaller::textChanged, &object, &CustomObject::textChanged);

//    static QString string ("passThis");

//    objectCaller.callMe(string);

    QApplication app(argc, argv);

    QQmlApplicationEngine engine(&app);
    QQmlContext *context = engine.rootContext();
    context->setContextProperty(QLatin1Literal("ObjectCpp"), &object);
    context->setContextProperty(QLatin1Literal("CallerCpp"), &objectCaller);

    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));
    if (engine.rootObjects().isEmpty())
        return -1;

    return app.exec();
}
