import QtQuick 2.11

import QtQuick.Controls 2.4
import QtQuick.VirtualKeyboard 2.3

ApplicationWindow {
    id: window
    visible: true
    width: 640
    height: 480
    title: qsTr("Tabs")

    SwipeView {
        id: swipeView
        anchors.fill: parent
        currentIndex: tabBar.currentIndex

        Connections {
            target: ObjectCpp;
            onTextChanged:{
                formOne.text = value + pointer;
            }
        }Connections {
            target: CallerCpp;
            onDoubleReply:{
                var arg1 = chartViewPtr ;
                var arg2 = chartMin     ;
                var arg3 = chartMax     ;

                var string =" " + arg1 + " " + arg2 + " " + arg3;
                print(string);
            }
        }

        Page1Form {
            id: formOne;
            Column{
                Row{
                    Button {
                        text: "ChangeText chartView"
                         onClicked: ObjectCpp.changeText(chartView);
                     }
                    Button {
                        text: "invoke pass through"
                         onClicked: CallerCpp.callMe("Send Text back from here.");
                     }
                    Button {
                        text: "callMeD"
                         onClicked: CallerCpp.callMeD(formOne.chartView,0.0,1.1234);
                     }
                    Button {
                       text: "ChangeText"
                        onClicked: ObjectCpp.changeText(formOne);
                    }
                }
            }
        }

        Page2Form {
        }
    }

    footer: TabBar {
        id: tabBar
        currentIndex: swipeView.currentIndex

        TabButton {
            text: qsTr("Page 1")
        }
        TabButton {
            text: qsTr("Page 2")
        }
    }

    InputPanel {
        id: inputPanel
        z: 99
        x: 0
        y: window.height
        width: window.width

        states: State {
            name: "visible"
            when: inputPanel.active
            PropertyChanges {
                target: inputPanel
                y: window.height - inputPanel.height
            }
        }
        transitions: Transition {
            from: ""
            to: "visible"
            reversible: true
            ParallelAnimation {
                NumberAnimation {
                    properties: "y"
                    duration: 250
                    easing.type: Easing.InOutQuad
                }
            }
        }
    }
}
